%define _xinputconf %{_sysconfdir}/X11/xinit/xinput.d/fcitx.conf
%{!?gtk2_binary_version: %define gtk2_binary_version %(pkg-config  --variable=gtk_binary_version gtk+-2.0)}
%{!?gtk3_binary_version: %define gtk3_binary_version %(pkg-config  --variable=gtk_binary_version gtk+-3.0)}

Name:			fcitx
Summary:		Free Chinese Input Toy for X (XIM)
Version:		4.2.3
Release:		1%{?dist}
License:		GPLv2+
Group:			User Interface/Desktops
URL:			http://code.google.com/p/%{name}/
Source0:		http://%{name}.googlecode.com/files/%{name}-%{version}_dict.tar.xz
Source1:		xinput-%{name}
BuildRequires:		pango-devel, dbus-devel, opencc-devel
BuildRequires:		wget, intltool, chrpath, sysconftool, opencc
BuildRequires:		cmake, libtool, doxygen, libicu-devel
BuildRequires:		qt-devel, gtk3-devel, gtk2-devel, libicu
BuildRequires:		libX11-devel, qt-x11, dbus-glib-devel, dbus-x11
BuildRequires:		desktop-file-utils
Requires:		%{name}-data = %{version}-%{release}
Requires:		imsettings 
Requires(post):		%{_sbindir}/alternatives
Requires(postun):	%{_sbindir}/alternatives
Requires:		%{name}-libs = %{version}-%{release}
Requires:		%{name}-gtk3 = %{version}-%{release}
Requires:		%{name}-gtk2 = %{version}-%{release}

%description
FCITX(Free Chinese Input Toy of X) is a collection of Simplified Chinese 
input methods for Linux. It supports Pinyin, QuWei and Table-based input 
methods. It's small and fast.

%package data
Summary:		Data files of FCITX
Group:			System Environment/Libraries
BuildArch:		noarch

%description data
The %{name}-data package provides shared datas for FCITX.

%package libs
Summary:                Shared libraries for FCITX
Group:                  System Environment/Libraries

%description libs
The %{name}-libs package provides shared libraries for FCITX

%package devel
Summary:		Development files for FCITX
Group:			Development/Libraries
Requires:		%{name}-libs = %{version}-%{release}
Requires:		libX11-devel

%description devel
The %{name}-devel package contains libraries and header files necessary for
developing programs using FCITX libraries.

%package table-chinese
Summary:		Chinese table of FCITX
Group:			System Environment/Libraries
BuildArch:		noarch
Requires:		%{name} = %{version}-%{release}

%description table-chinese
The %{name}-table-chinese package provides other Chinese table for FCITX.

%package gtk2
Summary:		FCITX im module for gtk2
Group:			System Environment/Libraries
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-libs = %{version}-%{release}

%description gtk2
This package contains ibus im module for gtk2.

%package gtk3
Summary:		FCITX im module for gtk3
Group:			System Environment/Libraries
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-libs = %{version}-%{release}
Requires:		imsettings-gnome

%description gtk3
This package contains fcitx im module for gtk3.

%package qt4
Summary:		FCITX im module for qt4
Group:			System Environment/Libraries
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-libs = %{version}-%{release}

%description qt4
This package contains fcitx im module for qt4.

%prep
%setup -q

%build
mkdir -p build
pushd build
%cmake .. -DENABLE_GTK3_IM_MODULE=On -DENABLE_QT_IM_MODULE=On -DENABLE_OPENCC=On
make VERBOSE=1 %{?_smp_mflags}

%install
pushd build
make install INSTALL="install -p" DESTDIR=$RPM_BUILD_ROOT
rm -f %{buildroot}%{_libdir}/*.la
popd

# remove rpath
#chrpath --delete %{buildroot}%{_bindir}/{*PYMB,mb2org,fcitx,readPYBase}

# fix doc path
#mkdir __doc
#mv %{buildroot}%{_datadir}/%{name}/doc/* __doc
#rm -rf %{buildroot}%{_datadir}/%-DENABLE_GTK3_IM_MODULE=On -DENABLE_QT_IM_MODULE=On{name}/doc
#rm -f __doc/{API.txt,Develop_Readme*,fcitx_trunk.doxyfile}

# install xinput config file
install -pm 644 -D %{SOURCE1} %{buildroot}%{_xinputconf}

%find_lang %{name}

desktop-file-install --delete-original \
  --dir ${RPM_BUILD_ROOT}%{_datadir}/applications \
  ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}-skin-installer.desktop

desktop-file-install --delete-original \
  --dir ${RPM_BUILD_ROOT}%{_datadir}/applications \
  ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}-configtool.desktop

desktop-file-install --delete-original \
  --dir ${RPM_BUILD_ROOT}%{_datadir}/applications \
  ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}.desktop

%clean
rm -rf %{buildroot}

%post 
%{_sbindir}/alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_xinputconf} 55 || :
update-desktop-database %{_datadir}/applications &>/dev/null || :

%postun  
if [ "$1" = "0" ]; then
  %{_sbindir}/alternatives --remove xinputrc %{_xinputconf} || :
  # if alternative was set to manual, reset to auto
  [ -L %{_sysconfdir}/alternatives/xinputrc -a "`readlink %{_sysconfdir}/alternatives/xinputrc`" = "%{_xinputconf}" ] && %{_sbindir}/alternatives --auto xinputrc || :
fi
update-desktop-database %{_datadir}/applications &>/dev/null || :

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post gtk2
%{_bindir}/update-gtk-immodules %{_host} || :

%postun gtk2
%{_bindir}/update-gtk-immodules %{_host} || :

%post gtk3
%{_bindir}/gtk-query-immodules-3.0-%{__isa_bits} --update-cache || :

%postun gtk3
%{_bindir}/gtk-query-immodules-3.0-%{__isa_bits} --update-cache || :

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog THANKS TODO COPYING
#%doc __doc/*
%config %{_xinputconf}
%{_bindir}/fcitx-*
%{_bindir}/fcitx
%{_bindir}/createPYMB
%{_bindir}/mb2org
%{_bindir}/mb2txt
%{_bindir}/readPYBase
%{_bindir}/readPYMB
%{_bindir}/scel2org
%{_bindir}/txt2mb
%{_datadir}/applications/%{name}-skin-installer.desktop
%{_datadir}/applications/%{name}-configtool.desktop
%{_datadir}/applications/%{name}.desktop
%{_datadir}/mime/packages/x-fskin.xml
%{_docdir}/%{name}/
%{_mandir}/man1/createPYMB.1.gz
%{_mandir}/man1/fcitx-remote.1.gz
%{_mandir}/man1/fcitx.1.gz
%{_mandir}/man1/mb2org.1.gz
%{_mandir}/man1/mb2txt.1.gz
%{_mandir}/man1/readPYBase.1.gz
%{_mandir}/man1/readPYMB.1.gz
%{_mandir}/man1/scel2org.1.gz
%{_mandir}/man1/txt2mb.1.gz
%{_datadir}/%{name}/

%files libs
%defattr(-,root,root,-)
%doc
%{_bindir}/fcitx4-config
%{_libdir}/libfcitx*.so.*
%{_libdir}/%{name}/

%files data
%defattr(-,root,root,-)
%doc 
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_datadir}/icons/hicolor/22x22/apps/%{name}.png
%{_datadir}/icons/hicolor/24x24/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
%{_datadir}/icons/hicolor/16x16/status/*.png
%{_datadir}/icons/hicolor/22x22/status/*.png
%{_datadir}/icons/hicolor/24x24/status/*.png
%{_datadir}/icons/hicolor/48x48/status/*.png
%{_datadir}/icons/hicolor/scalable/status/*.svg
%{_datadir}/icons/gnome/scalable/status/*.svg
%{_datadir}/%{name}/inputmethod/

%files devel
%defattr(-,root,root,-)
%doc 
%{_libdir}/libfcitx*.so
%{_libdir}/pkgconfig/fcitx*.pc
%{_includedir}/fcitx*
%{_datadir}/cmake/%{name}/

%files table-chinese
%defattr(-,root,root,-)
%doc
%{_datadir}/%{name}/table/qxm.conf
%{_datadir}/%{name}/table/qxm.mb
%{_datadir}/%{name}/table/cangjie.conf
%{_datadir}/%{name}/table/cj.mb
%{_datadir}/%{name}/table/db.conf
%{_datadir}/%{name}/table/db.mb
%{_datadir}/%{name}/table/erbi.conf
%{_datadir}/%{name}/table/erbi.mb
%{_datadir}/%{name}/table/wanfeng.conf
%{_datadir}/%{name}/table/wanfeng.mb
%{_datadir}/%{name}/table/wbpy.conf
%{_datadir}/%{name}/table/wbpy.mb
%{_datadir}/%{name}/table/zrm.conf
%{_datadir}/%{name}/table/zrm.mb

%files gtk2
%defattr(-,root,root,-)
%{_libdir}/gtk-2.0/%{gtk2_binary_version}/immodules/im-fcitx.so

%files gtk3
%defattr(-,root,root,-)
%{_libdir}/gtk-3.0/%{gtk3_binary_version}/immodules/im-fcitx.so

%files qt4
%defattr(-,root,root,-)
%{_libdir}/qt4/plugins/inputmethods/qtim-fcitx.so


%changelog
* Mon May 07 2012 Liang Suilong <liangsuilong@gmail.com> - 4.2.3-1
- Upgrade to fcitx-4.2.3

* Fri Apr 26 2012 Liang Suilong <liangsuilong@gmail.com> - 4.2.2-2
- Upgrade to fcitx-4.2.2

* Sun Apr 22 2012 Liang Suilong <liangsuilong@gmail.com> - 4.2.2-1
- Upgrade to fcitx-4.2.2

* Sat Feb 04 2012 Liang Suilong <liangsuilong@gmail.com> - 4.2.0-1
- Upgrade to fcitx-4.2.0

* Sun Dec 25 2011 Liang Suilong <liangsuilong@gmail.com> - 4.1.2-3
- Fix the spec

* Sun Dec 25 2011 Liang Suilong <liangsuilong@gmail.com> - 4.1.2-2
- Fix the spec

* Sun Dec 25 2011 Liang Suilong <liangsuilong@gmail.com> - 4.1.2-1
- Update to 4.1.2
- move fcitx4-config to devel

* Fri Sep 09 2011 Liang Suilong <liangsuilong@gmail.com> - 4.1.1-2
- Update xinput-fcitx
- Add fcitx-gtk3 as fcitx requires

* Fri Sep 09 2011 Liang Suilong <liangsuilong@gmail.com> - 4.1.1-1
- Upstream to fcitx-4.1.1

* Fri Sep 09 2011 Liang Suilong <liangsuilong@gmail.com> - 4.1.0-1
- Upstream to fcitx-4.1.0
- Add fcitx-gtk2 as FCITX im module for gtk2
- Add fcitx-gtk3 as FCITX im module for gtk3
- Add fcitx-qt4 as FCITX im module for qt4

* Tue Aug 02 2011 Liang Suilong <liangsuilong@gmail.com> - 4.0.1-5
- Fix that %files lists a wrong address
- Separate fcitx-libs again

* Tue Aug 02 2011 Liang Suilong <liangsuilong@gmail.com> - 4.0.1-4
- Separates varieties of tables from FCITX
- Merge fcitx-libs into fcitx 

* Sun Jul 03 2011 Liang Suilong <liangsuilong@gmail.com> - 4.0.1-3
- Support GNOME 3 tray icon
- Fix that main window is covered by GNOME Shell 

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Nov 19 2010 Chen Lei <supercyper@163.com> - 4.0.0-1
- Update to 4.0.0

* Mon Jun 14 2010 Chen Lei <supercyper@163.com> - 3.6.3-5.20100514svn_utf8
- Remove BR:libXext-devel

* Fri May 14 2010 Chen Lei <supercyper@163.com> - 3.6.3-4.20100514svn_utf8
- svn 365

* Sun Apr 18 2010 Chen Lei <supercyper@163.com> - 3.6.3-3.20100410svn_utf8
- Exclude xpm files

* Sat Apr 17 2010 Chen Lei <supercyper@163.com> - 3.6.3-2.20100410svn_utf8
- Update License tag
- Add more explanation for UTF-8 branch

* Mon Apr 12 2010 Chen Lei <supercyper@163.com> - 3.6.3-1.20100410svn_utf8
- Initial Package
